<?php

function plugin_stub_generate_plugin_content_type($plugin_name, $prefix) {
return <<<CONTENT
<?php

/**
 * @file
 * content_type plugin generated by drush ctools plugin stub.
 */

\$plugin = array(
  'title' => t('TITLE'),
  'description' => t('DESCRIPTION.'),
  'content_types' => array('$plugin_name'),
  'defaults' => array('{$prefix}_YOUR_VAR' => ''),
  'icon' => 'ctools_stub.png',
  'category' => t('CATEGORY'),
  'single' => TRUE,
);

/**
 * 'Edit' callback for the content type.
 */
function {$prefix}_content_type_edit_form(\$form, &\$form_state) {
  \$conf = \$form_state['conf'];
  \$form['{$prefix}_YOUR_VAR'] = array(
    '#type' => 'textfield',
    '#title' => t('TITLE'),
    '#description' => t('DESCRIPTION.'),
    '#default_value' => !empty(\$conf['{$prefix}_YOUR_VAR']) ? \$conf['{$prefix}_YOUR_VAR'] : '',
  );
  return \$form;
}

/**
 * The submit form stores the data in \$conf.
 */
function {$prefix}_content_type_edit_form_submit(\$form, &\$form_state) {
  foreach (array_keys(\$form_state['plugin']['defaults']) as \$key) {
    if (isset(\$form_state['values'][\$key])) {
      \$form_state['conf'][\$key] = \$form_state['values'][\$key];
    }
  }
}

/**
 * Put the output for you content type in the blocks content.
 */
function {$prefix}_content_type_render(\$subtype, \$conf, \$panel_args, \$context) {
  \$block = new stdClass();
  \$block->content = '';
  return \$block;
}

CONTENT;
}

/**
 * Finalize the plugin.
 *
 * Panels likes it when there is an icon for content types, so give the plugin
 * a default icon.
 */
function plugin_stub_finalize_content_type($plugin_name, $filename) {
  $parts = explode('/', dirname(__FILE__));
  // The icon file is one directory up from where we are, so pop one dir of the
  // stack.
  array_pop($parts);
  $src_path = implode('/', $parts);
  // Get the destination path.
  $pathinfo = pathinfo($filename);
  $dst = drush_cwd() . '/' . $pathinfo['dirname'] . '/ctools_stub.png';
  drush_op('copy', $src_path . '/ctools_stub.png', $dst);
}
